diff --git a/src/Lunr/Vortex/PAP/PAPResponse.php b/src/Lunr/Vortex/PAP/PAPResponse.php
index 4152b5bae4b55bf2314dea0502283bcc3f6a17c1..d7cc27bd2224b9339c8678f425bf33549e3a2f70 100644
--- a/src/Lunr/Vortex/PAP/PAPResponse.php
+++ b/src/Lunr/Vortex/PAP/PAPResponse.php
@@ -14,6 +14,7 @@ namespace Lunr\Vortex\PAP;
 
 use Lunr\Vortex\PushNotificationStatus;
 use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 
 /**
  * Google Cloud Messaging Push Notification response wrapper.
@@ -25,37 +26,37 @@ class PAPResponse implements PushNotificationResponseInterface
      * HTTP status code.
      * @var integer
      */
-    private $http_code;
+    private int $http_code;
 
     /**
      * Delivery status.
      * @var PushNotificationStatus::*
      */
-    private $status;
+    private int $status;
 
     /**
      * The HTTP response.
      * @var string
      */
-    private $result;
+    private string $result;
 
     /**
      * The PAP response info.
      * @var array
      */
-    private $pap_response;
+    private array $pap_response;
 
     /**
      * Push notification endpoint.
      * @var string
      */
-    private $endpoint;
+    private string $endpoint;
 
     /**
      * Raw payload that was sent to PAP.
      * @var string
      */
-    protected $payload;
+    protected string $payload;
 
     /**
      * Constructor.
@@ -65,7 +66,7 @@ class PAPResponse implements PushNotificationResponseInterface
      * @param string                   $device_id The deviceID that the message was sent to.
      * @param string                   $payload   Raw payload that was sent to PAP.
      */
-    public function __construct($response, $logger, $device_id, $payload)
+    public function __construct(\Requests_Response $response, LoggerInterface $logger, string $device_id, string $payload)
     {
         $this->http_code    = $response->status_code;
         $this->result       = $response->body;
@@ -155,7 +156,7 @@ class PAPResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    private function set_status($endpoint, $logger)
+    private function set_status(string $endpoint, LoggerInterface $logger)
     {
         switch ($this->http_code)
         {
@@ -223,7 +224,7 @@ class PAPResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         if ($endpoint != $this->endpoint)
         {
diff --git a/src/Lunr/Vortex/PAP/Tests/PAPDispatcherPushTest.php b/src/Lunr/Vortex/PAP/Tests/PAPDispatcherPushTest.php
index c3543ba194c199fcfb4bd2bb269c39645085d49a..98f2477669b4a11fb4c7dd61be039ca729555249 100644
--- a/src/Lunr/Vortex/PAP/Tests/PAPDispatcherPushTest.php
+++ b/src/Lunr/Vortex/PAP/Tests/PAPDispatcherPushTest.php
@@ -71,9 +71,9 @@ class PAPDispatcherPushTest extends PAPDispatcherTest
         $message = 'Dispatching push notification to {endpoint} failed: {error}';
         $context = [ 'endpoint' => 'endpoint', 'error' => 'Network error!' ];
 
-        $this->logger->expects($this->once())
+        $this->logger->expects($this->exactly(2))
                      ->method('warning')
-                     ->with($message, $context);
+                     ->withConsecutive([$message, $context], ['Parsing response of push notification to {endpoint} failed: {error}']);
 
         $this->assertInstanceOf('Lunr\Vortex\PAP\PAPResponse', $this->class->push($this->payload, $endpoints));
 
@@ -183,9 +183,9 @@ class PAPDispatcherPushTest extends PAPDispatcherTest
         $message = 'Dispatching push notification to {endpoint} failed: {error}';
         $context = [ 'endpoint' => 'endpoint', 'error' => 'Network error!' ];
 
-        $this->logger->expects($this->once())
+        $this->logger->expects($this->exactly(2))
                      ->method('warning')
-                     ->with($message, $context);
+                     ->withConsecutive([$message, $context], ['Parsing response of push notification to {endpoint} failed: {error}']);
 
         $this->class->push($this->payload, $endpoints);
 
diff --git a/src/Lunr/Vortex/PAP/Tests/PAPPayloadSetTest.php b/src/Lunr/Vortex/PAP/Tests/PAPPayloadSetTest.php
index 7e79a4467031555d0e4a39800bfcaafe759ffda9..edbef49458ccecf61b0f1a7b1d1e220aa1ba3292 100644
--- a/src/Lunr/Vortex/PAP/Tests/PAPPayloadSetTest.php
+++ b/src/Lunr/Vortex/PAP/Tests/PAPPayloadSetTest.php
@@ -45,16 +45,16 @@ class PAPPayloadSetTest extends PAPPayloadTest
     }
 
     /**
-     * Test that set_deliver_before_timestamp() sets the deliverbefore.
+     * Test that set_priority() sets the priority.
      *
      * @covers Lunr\Vortex\PAP\PAPPayload::set_priority
      */
     public function testSetPrioritySetsPriority(): void
     {
-        $priority = 'priority';
+        $priority = 1;
         $this->class->set_priority($priority);
 
-        $this->assertPropertyEquals('priority', 'priority');
+        $this->assertPropertyEquals('priority', 1);
     }
 
     /**
@@ -64,8 +64,7 @@ class PAPPayloadSetTest extends PAPPayloadTest
      */
     public function testSetPriorityReturnsSelfReference(): void
     {
-        $cid = 'cid';
-        $this->assertEquals($this->class, $this->class->set_priority($cid));
+        $this->assertEquals($this->class, $this->class->set_priority(2));
     }
 
 }
diff --git a/src/Lunr/Vortex/PAP/Tests/PAPResponseErrorTest.php b/src/Lunr/Vortex/PAP/Tests/PAPResponseErrorTest.php
index bc62143b077ebb7e05e83aa3cb5d3058fbc52663..339087233f0216190e2a7bd169ea1e839ca72e11 100644
--- a/src/Lunr/Vortex/PAP/Tests/PAPResponseErrorTest.php
+++ b/src/Lunr/Vortex/PAP/Tests/PAPResponseErrorTest.php
@@ -50,7 +50,7 @@ class PAPResponseErrorTest extends PAPResponseTest
      */
     public function testHttpCodeIsSetCorrectly(): void
     {
-        $this->assertPropertySame('http_code', FALSE);
+        $this->assertPropertySame('http_code', 0);
     }
 
     /**
diff --git a/src/Lunr/Vortex/PushNotificationDispatcherInterface.php b/src/Lunr/Vortex/PushNotificationDispatcherInterface.php
index 23dceafc7a622f1c6da47daa00fec018adae8698..a6d4f6d0c0e292a4e8285527490556b4fcea59bc 100644
--- a/src/Lunr/Vortex/PushNotificationDispatcherInterface.php
+++ b/src/Lunr/Vortex/PushNotificationDispatcherInterface.php
@@ -27,7 +27,7 @@ interface PushNotificationDispatcherInterface
      *
      * @return PushNotificationResponseInterface Response object
      */
-    public function push($payload, &$endpoints);
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface;
 
 }
 
diff --git a/src/Lunr/Vortex/PushNotificationResponseInterface.php b/src/Lunr/Vortex/PushNotificationResponseInterface.php
index eaa6e47c70c79fabb3f89a1a1ca0543bf6f79bf0..27fa5b2f8363377dcb205c3e16d0e73f03ad64f9 100644
--- a/src/Lunr/Vortex/PushNotificationResponseInterface.php
+++ b/src/Lunr/Vortex/PushNotificationResponseInterface.php
@@ -24,7 +24,7 @@ interface PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint);
+    public function get_status(string $endpoint): int;
 
 }
 
diff --git a/src/Lunr/Vortex/PushNotificationStatus.php b/src/Lunr/Vortex/PushNotificationStatus.php
index 20d4749273d001e92242d4526c90129700dadf93..6ff189d59c6fe2a211e80c336c0c15311cecbbf8 100644
--- a/src/Lunr/Vortex/PushNotificationStatus.php
+++ b/src/Lunr/Vortex/PushNotificationStatus.php
@@ -12,7 +12,7 @@
 namespace Lunr\Vortex;
 
 /**
- * Windows Phone Push Notification Priority Types.
+ * Push notification delivery status.
  */
 class PushNotificationStatus
 {
@@ -21,43 +21,43 @@ class PushNotificationStatus
      * Push notification status unknown.
      * @var integer
      */
-    const UNKNOWN = 0;
+    public const UNKNOWN = 0;
 
     /**
      * Push notification delivered successfully.
      * @var integer
      */
-    const SUCCESS = 1;
+    public const SUCCESS = 1;
 
     /**
      * Push notification could not be delivered. Try again later.
      * @var integer
      */
-    const TEMPORARY_ERROR = 2;
+    public const TEMPORARY_ERROR = 2;
 
     /**
      * Push notification endpoint invalid.
      * @var integer
      */
-    const INVALID_ENDPOINT = 3;
+    public const INVALID_ENDPOINT = 3;
 
     /**
      * Push notification not delivered because of client misconfiguration.
      * @var integer
      */
-    const CLIENT_ERROR = 4;
+    public const CLIENT_ERROR = 4;
 
     /**
      * Push notification not delivered because of server error.
      * @var integer
      */
-    const ERROR = 5;
+    public const ERROR = 5;
 
     /**
      * Push notification not processed by any dispatcher.
      * @var integer
      */
-    const NOT_HANDLED = 6;
+    public const NOT_HANDLED = 6;
 
 }
 
diff --git a/src/Lunr/Vortex/WNS/Tests/WNSResponseErrorTest.php b/src/Lunr/Vortex/WNS/Tests/WNSResponseErrorTest.php
index 2540fbdc7590c5872af18aa815c4607b482e0ad9..ca23930352633174371a706b36a144b513ef5c82 100644
--- a/src/Lunr/Vortex/WNS/Tests/WNSResponseErrorTest.php
+++ b/src/Lunr/Vortex/WNS/Tests/WNSResponseErrorTest.php
@@ -16,7 +16,7 @@ use Lunr\Vortex\PushNotificationStatus;
 /**
  * This class contains tests for failed WNS dispatches.
  *
- * @covers Lunr\Vortex\WNS\WNSResponse
+ * @covers \Lunr\Vortex\WNS\WNSResponse
  */
 class WNSResponseErrorTest extends WNSResponseTest
 {
@@ -34,7 +34,7 @@ class WNSResponseErrorTest extends WNSResponseTest
      */
     public function testHeadersIsNull(): void
     {
-        $this->assertNull($this->get_reflection_property_value('headers'));
+        $this->assertEquals(NULL, $this->get_reflection_property_value('headers'));
     }
 
     /**
diff --git a/src/Lunr/Vortex/WNS/Tests/WNSResponseTest.php b/src/Lunr/Vortex/WNS/Tests/WNSResponseTest.php
index 3a62f8088216dfb6b8a68ed9bd64f03d0825252d..28595206581d8bec31dd98e29dcdafda8a74f0b7 100644
--- a/src/Lunr/Vortex/WNS/Tests/WNSResponseTest.php
+++ b/src/Lunr/Vortex/WNS/Tests/WNSResponseTest.php
@@ -58,7 +58,7 @@ abstract class WNSResponseTest extends LunrBaseTest
     {
         $this->logger = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
 
-        $response = $this->getMockBuilder('Requests_Response')->getMock();
+        $response = $this->getMockBuilder('\Requests_Response')->getMock();
 
         $response->headers = [
             'Date'                         => '2016-01-13',
diff --git a/src/Lunr/Vortex/WNS/WNSBadgePayload.php b/src/Lunr/Vortex/WNS/WNSBadgePayload.php
index bab39fe24f65e383864343ada54f717e863ed805..6b4341bcd0f78f41cda8c1e240dfa958a0dd0b6c 100644
--- a/src/Lunr/Vortex/WNS/WNSBadgePayload.php
+++ b/src/Lunr/Vortex/WNS/WNSBadgePayload.php
@@ -38,7 +38,7 @@ class WNSBadgePayload extends WNSPayload
      *
      * @return string Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         $xml = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
         if (isset($this->elements['value']))
@@ -58,7 +58,7 @@ class WNSBadgePayload extends WNSPayload
      *
      * @return WNSBadgePayload Self Reference
      */
-    public function set_value($value)
+    public function set_value(string $value): self
     {
         $this->elements['value'] = $this->escape_string($value);
 
diff --git a/src/Lunr/Vortex/WNS/WNSDispatcher.php b/src/Lunr/Vortex/WNS/WNSDispatcher.php
index 84ae5d06f4345aee0066ee1efbe3fe28c201b777..882a8b4af4f665c725425b18f2cfe4ff32e74cbc 100644
--- a/src/Lunr/Vortex/WNS/WNSDispatcher.php
+++ b/src/Lunr/Vortex/WNS/WNSDispatcher.php
@@ -13,6 +13,8 @@
 namespace Lunr\Vortex\WNS;
 
 use Lunr\Vortex\PushNotificationDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 use Requests_Exception;
 use Requests_Response;
 
@@ -25,49 +27,49 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      * Client Secret to use when obtaining an oauth token
      * @var string|null
      */
-    protected $client_secret;
+    protected ?string $client_secret;
 
     /**
      * Client ID to use when obtaining an oauth token
      * @var string|null
      */
-    protected $client_id;
+    protected ?string $client_id;
 
     /**
      * The authentication token to identify the app channel
      * @var string|null
      */
-    private $oauth_token;
+    private ?string $oauth_token;
 
     /**
      * Push notification type.
      * @var string
      */
-    private $type;
+    private string $type;
 
     /**
      * Shared instance of the Requests_Session class.
      * @var \Requests_Session
      */
-    private $http;
+    private \Requests_Session $http;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * The URL to use to request an OAuth token.
      * @var string
      */
-    const TOKEN_URL = 'https://login.live.com/accesstoken.srf';
+    private const TOKEN_URL = 'https://login.live.com/accesstoken.srf';
 
     /**
      * The scope to request the oauth token from.
      * @var string
      */
-    const NOTIFICATION_SCOPE = 'notify.windows.com';
+    private const NOTIFICATION_SCOPE = 'notify.windows.com';
 
     /**
      * Constructor.
@@ -75,7 +77,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      * @param \Requests_Session        $http   Shared instance of the Requests_Session class.
      * @param \Psr\Log\LoggerInterface $logger Shared instance of a Logger.
      */
-    public function __construct($http, $logger)
+    public function __construct(\Requests_Session $http, LoggerInterface $logger)
     {
         $this->http          = $http;
         $this->logger        = $logger;
@@ -104,9 +106,9 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      * @param WNSPayload $payload   Payload object
      * @param array      $endpoints Endpoints to send to in this batch
      *
-     * @return WNSResponse Response object
+     * @return PushNotificationResponseInterface&WNSResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         if (!isset($this->oauth_token))
         {
@@ -177,7 +179,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return WNSDispatcher Self reference
      */
-    public function set_type($type)
+    public function set_type(string $type): self
     {
         if (in_array($type, [ WNSType::TOAST, WNSType::TILE, WNSType::RAW, WNSType::BADGE ]))
         {
@@ -194,7 +196,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return WNSDispatcher Self reference
      */
-    public function set_client_id($client_id)
+    public function set_client_id(string $client_id): self
     {
         $this->client_id = $client_id;
         return $this;
@@ -207,7 +209,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return WNSDispatcher Self reference
      */
-    public function set_client_secret($client_secret)
+    public function set_client_secret(string $client_secret): self
     {
         $this->client_secret = $client_secret;
         return $this;
@@ -263,7 +265,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return void
      */
-    public function set_oauth_token($token)
+    public function set_oauth_token(string $token): void
     {
         $this->oauth_token = $token;
     }
@@ -275,7 +277,7 @@ class WNSDispatcher implements PushNotificationDispatcherInterface
      *
      * @return \Requests_Response New instance of a Requests_Response object.
      */
-    protected function get_new_response_object_for_failed_request($endpoint)
+    protected function get_new_response_object_for_failed_request(string $endpoint): Requests_Response
     {
         $http_response = new Requests_Response();
 
diff --git a/src/Lunr/Vortex/WNS/WNSPayload.php b/src/Lunr/Vortex/WNS/WNSPayload.php
index 512a2a96d8aa50a91f04a15e88ae7f595b98d18e..0904d8e09f22366a9744fb9c358df1cee9e0519b 100644
--- a/src/Lunr/Vortex/WNS/WNSPayload.php
+++ b/src/Lunr/Vortex/WNS/WNSPayload.php
@@ -21,7 +21,7 @@ abstract class WNSPayload
      * Array of Push Notification elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Constructor.
@@ -46,7 +46,7 @@ abstract class WNSPayload
      *
      * @return string Escaped string
      */
-    protected function escape_string($string)
+    protected function escape_string(string $string): string
     {
         $search  = [ '&', '<', '>', '‘', '“' ];
         $replace = [ '&amp;', '&lt;', '&gt;', '&apos;', '&quot;' ];
@@ -59,7 +59,7 @@ abstract class WNSPayload
      *
      * @return string Payload
      */
-    public abstract function get_payload();
+    public abstract function get_payload(): string;
 
 }
 
diff --git a/src/Lunr/Vortex/WNS/WNSResponse.php b/src/Lunr/Vortex/WNS/WNSResponse.php
index b027e4582bc08daffa4d7faed5088528529098b4..c681d948b6cecc4d8cadcd2f86ebb33a6a67726c 100644
--- a/src/Lunr/Vortex/WNS/WNSResponse.php
+++ b/src/Lunr/Vortex/WNS/WNSResponse.php
@@ -12,12 +12,14 @@
 
 namespace Lunr\Vortex\WNS;
 
+use Lunr\Vortex\PushNotificationResponseInterface;
 use Lunr\Vortex\PushNotificationStatus;
+use Psr\Log\LoggerInterface;
 
 /**
  * Windows Push Notification response wrapper.
  */
-class WNSResponse
+class WNSResponse implements PushNotificationResponseInterface
 {
 
     /**
@@ -28,7 +30,7 @@ class WNSResponse
 
     /**
      * HTTP status code.
-     * @var integer
+     * @var mixed
      */
     private $http_code;
 
@@ -36,28 +38,28 @@ class WNSResponse
      * Delivery status.
      * @var PushNotificationStatus::*
      */
-    private $status;
+    private int $status;
 
     /**
      * Push notification endpoint.
      * @var string
      */
-    private $endpoint;
+    private string $endpoint;
 
     /**
      * Raw payload that was sent to WNS.
-     * @var string
+     * @var string|null
      */
-    protected $payload;
+    protected ?string $payload;
 
     /**
      * Constructor.
      *
      * @param \Requests_Response       $response Requests_Response object.
      * @param \Psr\Log\LoggerInterface $logger   Shared instance of a Logger.
-     * @param string                   $payload  Raw payload that was sent to WNS.
+     * @param string|null              $payload  Raw payload that was sent to WNS.
      */
-    public function __construct($response, $logger, $payload)
+    public function __construct(\Requests_Response $response, LoggerInterface $logger, ?string $payload)
     {
         $this->http_code = $response->status_code;
         $this->endpoint  = $response->url;
@@ -93,7 +95,7 @@ class WNSResponse
      *
      * @return void
      */
-    private function set_status($endpoint, $logger)
+    private function set_status(string $endpoint, LoggerInterface $logger)
     {
         switch ($this->http_code)
         {
@@ -157,7 +159,7 @@ class WNSResponse
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         if ($endpoint != $this->endpoint)
         {
diff --git a/src/Lunr/Vortex/WNS/WNSTilePayload.php b/src/Lunr/Vortex/WNS/WNSTilePayload.php
index 4211e74fd9f786ee1150ec6419cf375613b544f0..8a2df1bdcd4a6373eec64dcf33feb29c3fffd547 100644
--- a/src/Lunr/Vortex/WNS/WNSTilePayload.php
+++ b/src/Lunr/Vortex/WNS/WNSTilePayload.php
@@ -38,7 +38,7 @@ class WNSTilePayload extends WNSPayload
      *
      * @return string Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         $inner_xml = '';
         foreach ($this->elements['image'] as $key => $value)
@@ -75,9 +75,9 @@ class WNSTilePayload extends WNSPayload
      *
      * @param integer         $line The line on which to add the text
      *
-     * @return WNSTilePayload Self Reference
+     * @return self Self Reference
      */
-    public function set_text($text, $line = 0)
+    public function set_text($text, int $line = 0): self
     {
         if (!is_array($text))
         {
@@ -100,9 +100,9 @@ class WNSTilePayload extends WNSPayload
      *
      * @param integer         $line  The line on which to add the text
      *
-     * @return WNSTilePayload Self Reference
+     * @return self Self Reference
      */
-    public function set_image($image, $line = 0)
+    public function set_image($image, int $line = 0): self
     {
         if (!is_array($image))
         {
@@ -128,7 +128,7 @@ class WNSTilePayload extends WNSPayload
      *
      * @return WNSTilePayload Self Reference
      */
-    public function set_templates($templates)
+    public function set_templates($templates): self
     {
         if (!is_array($templates))
         {
diff --git a/src/Lunr/Vortex/WNS/WNSToastPayload.php b/src/Lunr/Vortex/WNS/WNSToastPayload.php
index c0046199d7df18243521939f3c8a9933d551de6c..335de39547d0d1de5a9d0576b2c9649c1055a40d 100644
--- a/src/Lunr/Vortex/WNS/WNSToastPayload.php
+++ b/src/Lunr/Vortex/WNS/WNSToastPayload.php
@@ -38,7 +38,7 @@ class WNSToastPayload extends WNSPayload
      *
      * @return string Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         $template = (isset($this->elements['template'])) ? $this->elements['template'] : 'ToastText0' . count($this->elements['text']);
 
@@ -78,9 +78,9 @@ class WNSToastPayload extends WNSPayload
      *
      * @param integer         $line The line on which to add the text
      *
-     * @return \Lunr\Vortex\WNS\WNSToastPayload Self Reference
+     * @return self Self Reference
      */
-    public function set_text($text, $line = 0)
+    public function set_text($text, int $line = 0): self
     {
         if (!is_array($text))
         {
@@ -101,9 +101,9 @@ class WNSToastPayload extends WNSPayload
      *
      * @param string $launch Launch parameters for the app
      *
-     * @return WNSToastPayload Self Reference
+     * @return self Self Reference
      */
-    public function set_launch($launch)
+    public function set_launch(string $launch): self
     {
         $this->elements['launch'] = $this->escape_string($launch);
 
@@ -117,9 +117,9 @@ class WNSToastPayload extends WNSPayload
      *
      * @see https://msdn.microsoft.com/en-us/library/windows/apps/windows.ui.notifications.toasttemplatetype
      *
-     * @return WNSToastPayload Self Reference
+     * @return self Self Reference
      */
-    public function set_template($template)
+    public function set_template(string $template): self
     {
         $this->elements['template'] = $this->escape_string($template);
 
@@ -131,9 +131,9 @@ class WNSToastPayload extends WNSPayload
      *
      * @param string $image Image to display
      *
-     * @return WNSToastPayload Self Reference
+     * @return self Self Reference
      */
-    public function set_image($image)
+    public function set_image(string $image): self
     {
         $this->elements['image'] = $this->escape_string($image);
 
diff --git a/src/Lunr/Vortex/WNS/WNSType.php b/src/Lunr/Vortex/WNS/WNSType.php
index d0f84f57cdf0b00508d8cc23b8aea4704e344396..5dd570cce1ed5b616bb5b1361d9a44ae107c8e6d 100644
--- a/src/Lunr/Vortex/WNS/WNSType.php
+++ b/src/Lunr/Vortex/WNS/WNSType.php
@@ -21,25 +21,25 @@ class WNSType
      * Tile notification.
      * @var string
      */
-    const TILE = 'tile';
+    public const TILE = 'tile';
 
     /**
      * Toast notification.
      * @var string
      */
-    const TOAST = 'toast';
+    public const TOAST = 'toast';
 
     /**
      * Badge notification.
      * @var string
      */
-    const BADGE = 'badge';
+    public const BADGE = 'badge';
 
     /**
      * Raw notification.
      * @var string
      */
-    const RAW = 'raw';
+    public const RAW = 'raw';
 
 }
 
